Package: alabaster.se
Title: Load and Save SummarizedExperiments from File
Version: 1.12.0
Date: 2024-10-16
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Description: 
    Save SummarizedExperiments into file artifacts, and load them back into memory.
    This is a more portable alternative to serialization of such objects into RDS files.
    Each artifact is associated with metadata for further interpretation;
    downstream applications can enrich this metadata with context-specific properties.
Depends: SummarizedExperiment, alabaster.base
Imports: methods, alabaster.ranges, alabaster.matrix, BiocGenerics,
        S4Vectors, IRanges, GenomicRanges, jsonlite
Suggests: rmarkdown, knitr, testthat, BiocStyle
VignetteBuilder: knitr
RoxygenNote: 7.3.1
biocViews: DataImport, DataRepresentation
git_url: https://git.bioconductor.org/packages/alabaster.se
git_branch: RELEASE_3_23
git_last_commit: 4fe9760
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 20:33:51 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

#' Save a SummarizedExperiment to disk
#'
#' Save a \linkS4class{SummarizedExperiment} to its on-disk representation.
#' 
#' @param x A \linkS4class{SummarizedExperiment} object or one of its subclasses.
#' @inheritParams alabaster.base::saveObject
#' @param SummarizedExperiment.allow.dataframe.assay Logical scalar indicating whether to allow data frames as assays of \code{x}.
#' @param ... Further arguments to pass to internal \code{\link{altSaveObject}} calls.
#'
#' @return \code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
#'
#' @details
#' By default, we consider the presence of data frames in the assays to be an error.
#' Users should coerce these into an appropriate matrix type, e.g., a dense matrix or a sparse dgCMatrix.
#' If a DataFrame as an assay is truly desired, users may set \code{\link{options}(alabaster.se.reject_data.frames=FALSE)} to skip the error.
#' Note that this only works for \linkS4class{DataFrame} objects - data.frame objects will not be saved correctly.
#'
#' @author Aaron Lun
#' @seealso
#' \code{\link{readSummarizedExperiment}}, to read the SummarizedExperiment back into the R session.
#' 
#' @examples
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' se <- SummarizedExperiment(list(counts=mat))
#' se$stuff <- LETTERS[1:10]
#' rowData(se)$blah <- runif(1000)
#' metadata(se)$whee <- "YAY"
#' 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @aliases stageObject,SummarizedExperiment-method
#' @name saveSummarizedExperiment
NULL

#' @export
#' @rdname saveSummarizedExperiment
#' @importFrom SummarizedExperiment colData rowData
#' @importFrom S4Vectors make_zero_col_DFrame
#' @importFrom jsonlite toJSON
#' @import alabaster.base
#' @import methods
setMethod("saveObject", "SummarizedExperiment", function(x, path, SummarizedExperiment.allow.dataframe.assay=FALSE, ...) {
    dir.create(path)
    saveObjectFile(
        path, 
        "summarized_experiment", 
        list(summarized_experiment=list(version="1.0", dimensions=dim(x)))
    )

    args <- list(SummarizedExperiment.allow.dataframe.assay=SummarizedExperiment.allow.dataframe.assay, ...)

    cd <- colData(x)
    empty.cd <- make_zero_col_DFrame(nrow(cd))
    if (!identical(cd, empty.cd)) { # respect row names, metadata, mcols...
        tryCatch({
            do.call(altSaveObject, c(list(cd, file.path(path, "column_data")), args))
        }, error=function(e) {
            stop("failed to stage 'colData(<", class(x)[1], ">)'\n  - ", e$message)
        })
    }

    rd <- rowData(x)
    empty.rd <- make_zero_col_DFrame(nrow(rd))
    if (!identical(rd, empty.rd)) { # respect row names, metadata, mcols...
        tryCatch({
            do.call(altSaveObject, c(list(rd, file.path(path, "row_data")), args))
        }, error=function(e) {
            stop("failed to stage 'rowData(<", class(x)[1], ">)'\n  - ", e$message)
        })
    }

    all.assays <- assays(x, withDimnames=FALSE)
    num.assays <- length(all.assays)
    if (num.assays) {
        adir <- file.path(path, "assays")
        dir.create(adir)

        ass.names <- assayNames(x)
        if (is.null(ass.names)) {
            stop("assays should be named")
        } else if (any(ass.names == "")) {
            stop("assays should have non-empty names")
        } else if (anyDuplicated(ass.names)) {
            stop("assays should be uniquely named")
        }
        write(toJSON(ass.names), file=file.path(adir, "names.json"))

        for (i in seq_along(ass.names)) {
            aname <- as.character(i - 1L)
            curmat <- all.assays[[i]]

            if (is.data.frame(curmat) || (is(curmat, "DataFrame") && !SummarizedExperiment.allow.dataframe.assay)) {
                stop("assays should not contain data frames, see ?'saveObject,SummarizedExperiment-method'")
            }

            tryCatch({
                do.call(altSaveObject, c(list(curmat, file.path(adir, aname)), args))
            }, error=function(e) {
                stop("failed to stage 'assay(<", class(x)[1], ">, ", i, ")'\n  - ", e$message)
            })
        }
    }

    saveMetadata(x, metadata.path=file.path(path, "other_data"), mcols.path=NULL)
})

##################################
######### OLD STUFF HERE #########
##################################

#' @export
setMethod("stageObject", "SummarizedExperiment", function(x, dir, path, child=FALSE, meta.name="experiment.json", ...) {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    cd <- colData(x)
    empty.cd <- make_zero_col_DFrame(nrow(cd))
    cd.info <- NULL
    if (!identical(cd, empty.cd)) {
        cd.info <- tryCatch({
            info <- .stageObject(cd, dir, file.path(path, "coldata"), child=TRUE)
            list(resource=.writeMetadata(info, dir=dir))
        }, error=function(e) {
            stop("failed to stage 'colData(<", class(x)[1], ">)'\n  - ", e$message)
        })
    }

    ass.info <- .stage_assays(x, dir, path)
    meta.info <- .processMetadata(x, dir, path, "metadata")

    rd <- rowData(x)
    empty.rd <- make_zero_col_DFrame(nrow(rd))
    rd.info <- NULL
    if (!identical(rd, empty.rd)) {
        rd.info <- tryCatch({
            info <- .stageObject(rd, dir, file.path(path, "rowdata"), child=TRUE)
            list(resource=.writeMetadata(info, dir=dir))
        }, error=function(e) {
            stop("failed to stage 'rowData(<", class(x)[1], ">)'\n  - ", e$message)
        })
    }

    list(
        `$schema`="summarized_experiment/v1.json",
        path=file.path(path, meta.name),
        summarized_experiment=list(
            assays=ass.info,
            column_data=cd.info,
            row_data=rd.info,
            other_data=meta.info,
            dimensions=dim(x)
        ),
        is_child=child
    )
})

#' @importMethodsFrom alabaster.matrix stageObject
#' @importFrom SummarizedExperiment assay assays assayNames
.stage_assays <- function(x, dir, path) {
    ass.names <- assayNames(x)
    if (is.null(ass.names) && length(assays(x)) > 0) {
        stop("assays should be named in a ", class(x)[1], " object")
    }
    if (anyDuplicated(ass.names)) {
        stop("detected duplicate assay names in a ", class(x)[1], " object")
    }
    if (any(ass.names == "")) {
        stop("detected empty assay name in a ", class(x)[1], " object")
    }

    all.meta <- vector("list", length(ass.names))

    for (i in seq_along(all.meta)) {
        curmat <- assay(x, i, withDimnames=FALSE)
        if (is.data.frame(curmat) || (is(curmat, "DataFrame") && getOption("alabaster.se.reject_data.frames", TRUE))) {
            stop("assays should not contain data frames, see ?'stageObject,SummarizedExperiment-method'")
        }

        mat.path <- file.path(path, paste0("assay-", i))
        deets <- tryCatch({
            meta <- .stageObject(curmat, path=mat.path, dir=dir, child=TRUE)
            .writeMetadata(meta, dir=dir)
        }, error=function(e) stop("failed to stage 'assay(<", class(x)[1], ">, ", i, ")'\n  - ", e$message))

        all.meta[[i]] <- list(name=ass.names[i], resource=deets)
    }

    all.meta
}

.onLoad <- function(libname, pkgname) {
    registerReadObjectFunction("summarized_experiment", readSummarizedExperiment)
    registerReadObjectFunction("ranged_summarized_experiment", readRangedSummarizedExperiment)
}

.onUnload <- function(libname, pkgname) {
    registerReadObjectFunction("summarized_experiment", NULL)
    registerReadObjectFunction("ranged_summarized_experiment", NULL)
}

#' Read a SummarizedExperiment from disk
#'
#' Read a \linkS4class{SummarizedExperiment} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created using the \code{\link{saveObject}} method for \linkS4class{SummarizedExperiment} objects.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments passed to internal \code{\link{altReadObject}} calls.
#' 
#' @return A \linkS4class{SummarizedExperiment} object.
#'
#' @author Aaron Lun
#' @seealso
#' \code{"\link{saveObject,SummarizedExperiment-method}"}, to save the SummarizedExperiment to disk.
#'
#' @examples
#' # Mocking up an experiment:
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' se <- SummarizedExperiment(list(counts=mat))
#' se$stuff <- LETTERS[1:10]
#' rowData(se)$blah <- runif(1000)
#' metadata(se)$whee <- "YAY"
#' 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadSummarizedExperiment
#'
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom jsonlite fromJSON
#' @importFrom S4Vectors make_zero_col_DFrame
#' @import alabaster.base
readSummarizedExperiment <- function(path, metadata, ...) {
    info <- metadata$summarized_experiment

    all.assays <- list()
    names(all.assays) <- character(0)
    if (file.exists(file.path(path, "assays"))) {
        ass.names <- fromJSON(file.path(path, "assays", "names.json"))
        for (y in seq_along(ass.names)) {
            all.assays[[ass.names[y]]] <- altReadObject(file.path(path, "assays", y - 1L), ...)
        }
    }

    cd.path <- file.path(path, "column_data")
    if (file.exists(cd.path)) {
        cd <- altReadObject(cd.path, ...)
    } else {
        cd <- make_zero_col_DFrame(info$dimensions[[2]])
    }

    rd.path <- file.path(path, "row_data")
    if (file.exists(rd.path)) {
        rd <- altReadObject(rd.path, ...)
    } else {
        rd <- make_zero_col_DFrame(info$dimensions[[1]])
    }

    se <- SummarizedExperiment(all.assays, colData=cd, rowData=rd, checkDimnames=FALSE)

    # Need to force the dimnames to match the DFs, because if they're NULL,
    # the dimnames from the assays end up being used instead.
    rownames(se) <- rownames(rd)
    colnames(se) <- rownames(cd)

    readMetadata(se, mcols.path=NULL, metadata.path = file.path(path, "other_data"))
}

##################################
######### OLD STUFF HERE #########
##################################

#' @export
loadSummarizedExperiment <- function(exp.info, project) {
    all.assays <- list()
    for (y in seq_along(exp.info$summarized_experiment$assays)) {
        cur.ass <- exp.info$summarized_experiment$assays[[y]]
        aname <- cur.ass$name
        apath <- cur.ass$resource$path
        ass.info <- acquireMetadata(project, apath)
        all.assays[[aname]] <- .loadObject(ass.info, project=project)
    }

    cd.meta <- exp.info$summarized_experiment$column_data
    if (!is.null(cd.meta)) {
        cd.info <- acquireMetadata(project, cd.meta$resource$path)
        cd <- .loadObject(cd.info, project=project)
    } else {
        cd <- make_zero_col_DFrame(exp.info$summarized_experiment$dimensions[[2]])
    }

    rd.meta <- exp.info$summarized_experiment$row_data
    if (!is.null(rd.meta)) {
        rd.info <- acquireMetadata(project, rd.meta$resource$path)
        rd <- .loadObject(rd.info, project=project)
    } else {
        rd <- make_zero_col_DFrame(exp.info$summarized_experiment$dimensions[[1]])
    }

    range.info <- exp.info$summarized_experiment$row_ranges
    if (is.null(range.info)) {
        se <- SummarizedExperiment(all.assays, colData=cd, rowData=rd, checkDimnames=FALSE)
    } else {
        rr.info <- acquireMetadata(project, range.info$resource$path)
        rr <- .loadObject(rr.info, project=project)
        mcols(rr) <- rd
        se <- SummarizedExperiment(all.assays, colData=cd, rowRanges=rr, checkDimnames=FALSE)
    }

    # Need to force the dimnames to match the DFs, because if they're NULL,
    # the dimnames from the assays end up being used instead.
    rownames(se) <- rownames(rd)
    colnames(se) <- rownames(cd)

    .restoreMetadata(se, NULL, meta.data = exp.info$summarized_experiment$other_data, project = project)
}

# This tests the stageObject generic for base SE's.
# library(testthat); library(alabaster.se); source("test-SummarizedExperiment.R")

# Making an SE and annotating it.
mat <- matrix(rpois(2000, 10), ncol=10)
colnames(mat) <- paste0("SAMPLE_", seq_len(ncol(mat)))

se <- SummarizedExperiment(list(counts=mat, cpm=mat/10))
se$stuff <- LETTERS[1:10]
se$blah <- runif(10)
rowData(se)$whee <- runif(nrow(se))

rownames(se) <- sprintf("GENE_%i", seq_len(nrow(se)))

test_that("stageObject works as expected for SE objects", {
    tmp <- tempfile()
    dir.create(tmp)

    out <- stageObject(se, tmp, "rnaseq")
    expect_identical(vapply(out$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))

    cdf <- read.csv(file.path(tmp, out$summarized_experiment$column_data$resource$path), row.names=1)
    expect_equal(cdf, as.data.frame(colData(se)))

    rdf <- read.csv(file.path(tmp, out$summarized_experiment$row_data$resource$path), row.names=1)
    expect_equal(rdf, as.data.frame(rowData(se)))

    # Doesn't save empty metadata.
    expect_null(out$summarized_experiment$other_data)

    # Round-tripping it to see that it's okay.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rownames(se), rownames(out2))
    expect_equal(rowData(se)[,1], rowData(out2)$whee)
    expect_equal(sum(assay(se)), sum(assay(out2)))
    expect_equal(sum(assay(se, 2)), sum(assay(out2, 2)))

    # Metadata is succcessfully saved.
    .writeMetadata(out, tmp)
    expect_true(file.exists(file.path(tmp, out$path)))
    deets <- jsonlite::fromJSON(file.path(tmp, out$path))
    expect_null(deets$md5sum)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rownames(se), rownames(out2))
    expect_equal(rowData(se)[,1], rowData(out2)$whee)
    expect_equal(sum(assay(se)), sum(assay(out2)))
    expect_equal(sum(assay(se, 2)), sum(assay(out2, 2)))
})

test_that("stageObject works as expected with no row or column names", {
    tmp <- tempfile()
    dir.create(tmp)
    dimnames(se) <- NULL

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_identical(vapply(out$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))

    cdf <- read.csv(file.path(tmp, out$summarized_experiment$column_data$resource$path))
    expect_equal(cdf, as.data.frame(colData(se)))

    rdf <- read.csv(file.path(tmp, out$summarized_experiment$row_data$resource$path))
    expect_equal(rdf, as.data.frame(rowData(se)))

    # Round-tripping it to see that it's okay.
    # This only works when the row names are NULL,
    # as we can't even form the MAE otherwise.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))

    # Works in the new world.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))
})

test_that("saveObject works as expected with no assays", {
    tmp <- tempfile()
    se <- SummarizedExperiment()
    saveObject(se, tmp)
    expect_identical(readObject(tmp), se)

    # Plus some dimensions, at least.
    tmp <- tempfile()
    se <- SummarizedExperiment(colData=DataFrame(row.names=LETTERS), rowData=DataFrame(row.names=1:10))
    saveObject(se, tmp)
    expect_identical(readObject(tmp), se)
})

test_that("stageObject works as expected with no row or column data, but still names", {
    tmp <- tempfile()
    dir.create(tmp)

    colData(se) <- colData(se)[,0]
    rowData(se) <- rowData(se)[,0]

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_identical(vapply(out$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))

    cdf <- read.csv(file.path(tmp, out$summarized_experiment$column_data$resource$path), row.names=1)
    expect_equal(cdf, as.data.frame(colData(se)))

    rdf <- read.csv(file.path(tmp, out$summarized_experiment$row_data$resource$path), row.names=1)
    expect_equal(rdf, as.data.frame(rowData(se)))

    # Round-tripping to make sure it's okay.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))

    # Works in the new world.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))
})

test_that("stageObject works as expected with no row or column data at all", {
    tmp <- tempfile()
    dir.create(tmp)

    colData(se) <- colData(se)[,0]
    rowData(se) <- rowData(se)[,0]
    dimnames(se) <- list(NULL, NULL)

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_identical(vapply(out$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))

    expect_null(out$summarized_experiment$column_data)
    expect_null(out$summarized_experiment$row_data)

    # Round-tripping to make sure it's okay.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))

    # Works in the new world.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowData(se), rowData(out2))
    expect_false(file.exists(file.path(tmp, "row_data")))
    expect_false(file.exists(file.path(tmp, "column_data")))
})

test_that("stageObject fails when the assay names are NULL or non-unique", {
    tmp <- tempfile()
    dir.create(tmp)
    ass <- assays(se)
    names(ass) <- NULL
    assays(se) <- ass
    expect_error(stageObject(se, tmp, "rnaseq"), "should be named")

    tmp <- tempfile()
    expect_error(saveObject(se, tmp), "should be named")

    # Duplicated
    tmp <- tempfile()
    dir.create(tmp)
    assayNames(se) <- rep("FOO", length(assays(se)))
    expect_error(stageObject(se, tmp, "rnaseq"), "duplicate")

    tmp <- tempfile()
    expect_error(saveObject(se, tmp), "unique")

    # Empty.
    tmp <- tempfile()
    dir.create(tmp)
    assayNames(se) <- c("", head(LETTERS, length(assayNames(se)) - 1))
    expect_error(stageObject(se, tmp, "rnaseq"), "empty")

    tmp <- tempfile()
    expect_error(saveObject(se, tmp), "empty")
})

test_that("stageObject works with the various types of vectors", {
    tmp <- tempfile()
    dir.create(tmp)

    se$stuff <- rep(LETTERS[1:3], length.out=ncol(se))
    se$blah <- factor(se$stuff, LETTERS[10:1])
    se$foo <- seq_len(ncol(se))
    se$whee <- as.numeric(10 + seq_len(ncol(se)))
    se$rabbit <- factor(se$stuff, LETTERS[1:3], ordered=TRUE)
    se$birthday <- rep(Sys.Date(), ncol(se)) - sample(100, ncol(se))

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)

    meta <- jsonlite::fromJSON(file.path(tmp, paste0(out$summarized_experiment$column_data$resource$path, ".json")), simplifyVector=FALSE)$data_frame
    expect_identical(meta$columns[[1]]$type, "string")
    expect_identical(read.csv(file.path(tmp, meta$columns[[2]]$levels$resource$path))[,1], LETTERS[10:1])
    expect_identical(meta$columns[[3]]$type, "integer")
    expect_identical(meta$columns[[4]]$type, "number")
    expect_identical(meta$columns[[5]]$type, "factor")
    expect_true(meta$columns[[5]]$ordered)
    expect_identical(read.csv(file.path(tmp, meta$columns[[5]]$levels$resource$path))[,1], LETTERS[1:3])
    expect_identical(meta$columns[[6]]$type, "string")
    expect_identical(read.csv(file.path(tmp, meta$columns[[5]]$levels$resource$path))[,1], LETTERS[1:3])
    expect_identical(meta$columns[[6]]$format, "date")

    # Round-tripping to make sure it's okay.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_identical(out2$stuff, se$stuff)
    expect_identical(out2$blah, se$blah)
    expect_identical(out2$foo, se$foo)
    expect_identical(out2$whee, se$whee)
    expect_identical(out2$rabbit, se$rabbit)
    expect_identical(out2$birthday, se$birthday)
})

test_that("stageObject handles data frames in the assays", {
    tmp <- tempfile()
    dir.create(tmp)

    assay(se) <- as.data.frame(assay(se))
    expect_error(stageObject(se, tmp, "df_fail"), "should not contain data.frame")

    opt <- options(alabaster.se.reject_data.frames=FALSE)
    on.exit(options(alabaster.se.reject_data.frames=TRUE))

    # still doesn't handle data.frame...
    expect_error(stageObject(se, tmp, "df_fail2"), "should not contain data.frame")

    # but now can handle DataFrame.
    se2 <- se
    assay(se2) <- as(assay(se2), "DataFrame")
    expect_error(out <- stageObject(se2, tmp, "rnaseq"), NA)
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)

    path <- file.path(tmp, out$summarized_experiment$assays[[1]]$resource$path)
    meta <- jsonlite::fromJSON(paste0(path, ".json"), simplifyVector=FALSE)
    expect_match(meta[["$schema"]], "data_frame/")

    # Works in the new world.
    tmp <- tempfile()
    expect_error(saveObject(se, tmp), "should not contain data frames")

    tmp <- tempfile()
    saveObject(se2, tmp, SummarizedExperiment.allow.dataframe.assay=TRUE)
    out2 <- readObject(tmp)
    expect_identical(assay(se2), assay(out2))
})

test_that("stageExperiment saves other metadata when necessary", {
    tmp <- tempfile()
    dir.create(tmp)

    metadata(se)$YAY <- 1
    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_true(file.exists(file.path(tmp, out$summarized_experiment$other_data$resource$path)))

    round <- loadSummarizedExperiment(out, tmp)
    expect_identical(metadata(round), list(YAY=1))

    # Works in the new world.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_identical(metadata(out2), list(YAY=1))
})

# This tests the RangedSummarizedExperiment staging.
# library(testthat); library(alabaster.se); source("test-RangedSummarizedExperiment.R")

set.seed(100)

# Making an SE and annotating it.
mat <- matrix(rpois(2000, 10), ncol=10)
colnames(mat) <- paste0("SAMPLE_", seq_len(ncol(mat)))

se <- SummarizedExperiment(list(counts=mat, cpm=mat/10), rowRanges=GRanges("chrA", IRanges(1:200, width=1)))
se$stuff <- LETTERS[1:10]
se$blah <- runif(10)
rowData(se)$whee <- runif(nrow(se))

test_that("stageObject works as expected for RSE objects", {
    tmp <- tempfile()
    dir.create(tmp)

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_identical(vapply(out$summarized_experiment$assays, function(x) x$name, ""), assayNames(se))

    # Make sure that no mcols were saved for the ranges.
    rr.meta <- acquireMetadata(tmp, out$summarized_experiment$row_ranges$resource$path)
    rr.round <- loadObject(rr.meta, tmp)
    expect_identical(ncol(mcols(rr.round)), 0L)

    # Round trip works.
    out2 <- loadSummarizedExperiment(out, tmp)
    expect_equal(colData(se), colData(out2))
    expect_equal(rowRanges(se), rowRanges(out2))
    expect_identical(length(rowData(out2)$whee), nrow(se))

    # The new world works.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_identical(colData(se), colData(out2))
    expect_identical(rowRanges(se), rowRanges(out2))
    expect_true(file.exists(file.path(tmp, "row_ranges", "OBJECT")))
    expect_false(file.exists(file.path(tmp, "row_ranges", "range_annotations")))
})

test_that("saveObject preserves RSE rownames", {
    copy <- se
    rownames(copy) <- sprintf("GENE_%i", seq_len(nrow(copy)))

    tmp <- tempfile()
    saveObject(copy, tmp)
    out2 <- readObject(tmp)

    expect_identical(rownames(out2), rownames(copy))
    expect_identical(rowRanges(out2), rowRanges(copy))
    expect_identical(rowData(out2), rowData(copy))
})

test_that("stageObject auto-skips on empty rowRanges", {
    tmp <- tempfile()
    dir.create(tmp)

    # GRL is empty.
    copy <- GRangesList(rep(list(GRanges()), nrow(se)))
    names(copy) <- rownames(se)
    rowRanges(se) <- copy
    expect_true(emptyRowRanges(se))

    out <- stageObject(se, tmp, "rnaseq", skip.ranges=NA)
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)

    expect_null(out$summarized_experiment$row_ranges)
    expect_null(out$summarized_experiment$row_data)

    out2 <- loadSummarizedExperiment(out, tmp)
    expect_identical(as.character(class(out2)), "SummarizedExperiment")

    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_s4_class(out2, "RangedSummarizedExperiment")
    expect_true(emptyRowRanges(out2))
    expect_false(file.exists(file.path(tmp, "row_ranges")))

    # Non-empty rowData but GRL is still empty.
    mcols(copy)$FOO <- 2
    rowRanges(se) <- copy

    out <- stageObject(se, tmp, "rnaseq2", skip.ranges=NA)
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)

    expect_null(out$summarized_experiment$row_ranges)
    mpath <- out$summarized_experiment$row_data$resource$path
    expect_match(jsonlite::fromJSON(file.path(tmp, paste0(mpath, ".json")))[["$schema"]], "csv_data_frame")

    out2 <- loadSummarizedExperiment(out, tmp)
    expect_identical(as.character(class(out2)), "SummarizedExperiment")
    expect_identical(unique(rowData(out2)$FOO), 2)

    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_s4_class(out2, "RangedSummarizedExperiment")
    expect_true(emptyRowRanges(out2))
    expect_identical(unique(rowData(out2)$FOO), 2)
    expect_false(file.exists(file.path(tmp, "row_ranges")))
})

test_that("stageObject allows us to forcibly skip the ranges", {
    tmp <- tempfile()
    dir.create(tmp)

    out <- stageObject(se, tmp, "rnaseq", skip.ranges=TRUE)
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    expect_true("row_data" %in% names(out$summarized_experiment))
    expect_false("row_ranges" %in% names(out$summarized_experiment))

    out2 <- loadSummarizedExperiment(out, tmp)
    expect_identical(as.character(class(out2)), "SummarizedExperiment")
})

rowRanges(se) <- splitAsList(rowRanges(se), seq_len(nrow(se)))
rownames(se) <- paste0("FEATURE_", seq_len(nrow(se)))

test_that("stageObject handles GRLs", {
    tmp <- tempfile()
    dir.create(tmp)

    out <- stageObject(se, tmp, "rnaseq")
    expect_error(alabaster.base::.writeMetadata(out, tmp), NA)
    rrmeta <- jsonlite::fromJSON(file.path(tmp, paste0(out$summarized_experiment$row_ranges$resource$path, ".json")), simplifyVector=FALSE)
    expect_true(rrmeta$compressed_list$names)

    grouping <- read.csv(file.path(tmp, rrmeta$path), row.names=1)
    expect_true(all(grouping$number==1L))
    expect_identical(rownames(grouping), rownames(se))

    # Again, make sure that no mcols were saved for the ranges.
    rr.meta <- acquireMetadata(tmp, out$summarized_experiment$row_ranges$resource$path)
    rr.round <- loadObject(rr.meta, tmp)
    expect_identical(ncol(mcols(rr.round)), 0L)

    # Round trip works.
    out2 <- loadSummarizedExperiment(out, tmp)
    ref <- rowRanges(se)
    metadata(ref) <- list()
    metadata(ref@unlistData) <- list()
    expect_equal(rowRanges(out2), ref)
    expect_s4_class(rowRanges(out2), "GenomicRangesList")

    # The new world works.
    tmp <- tempfile()
    saveObject(se, tmp)
    out2 <- readObject(tmp)
    expect_identical(rowRanges(se), ref)
})

#' Is the \code{rowRanges} empty?
#'
#' Check the \code{\link{rowRanges}} of a \linkS4class{RangedSummarizedExperiment} is empty, 
#' i.e., a \linkS4class{GRangesList} with no ranges. 
#' 
#' @param x A \linkS4class{RangedSummarizedExperiment} object or the contents of its \code{\link{rowRanges}}.
#'
#' @return A logical scalar indicating whether \code{x} has empty \code{rowRanges}.
#'
#' @details
#' Metadata in \code{\link{mcols}} is ignored for the purpose of this discussion, 
#' as this can be moved to the \code{\link{rowData}(x)} of the base \linkS4class{SummarizedExperiment} class without loss.
#' In other words, non-empty \code{\link{mcols}} will not be used to determine that the \code{rowRanges} is not empty.
#' However, non-empty fields in the \code{\link{metadata}} or in the inner \code{\link{mcols}} of the \linkS4class{GRanges} will trigger a non-emptiness decision.
#' 
#' @examples
#' emptyRowRanges(SummarizedExperiment())
#' emptyRowRanges(SummarizedExperiment(rowRanges=GRanges()))
#' emptyRowRanges(SummarizedExperiment(rowRanges=GRangesList()))
#' @export
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom IRanges PartitioningByEnd
#' @importFrom GenomicRanges GRanges
#' @importFrom S4Vectors mcols<- mcols
#' @importFrom BiocGenerics relist
emptyRowRanges <- function(x) {
    if (is(x, "SummarizedExperiment")) {
        x <- rowRanges(x)
    }
    if (is(x, "GRangesList")) {
        # Creating an empty GRL and comparing it. This re-uses the same
        # code as the SE->RSE coerce method, more or less.
        partitioning <- PartitioningByEnd(integer(length(x)), names = names(x))
        rowRanges <- relist(GRanges(), partitioning)
        mcols(x) <- mcols(rowRanges, use.names = FALSE)
        identical(x, rowRanges)
    } else {
        FALSE
    }
}

#' Save a RangedSummarizedExperiment to disk
#'
#' Save a \linkS4class{RangedSummarizedExperiment} to its on-disk representation.
#' 
#' @param x A \linkS4class{RangedSummarizedExperiment} object or one of its subclasses.
#' @inheritParams alabaster.base::saveObject
#' @param ... Further arguments to pass to \code{"\link{saveObject,SummarizedExperiment-method}"} and internal \code{\link{altSaveObject}} calls.
#'
#' @return \code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
#'
#' @author Aaron Lun
#' @seealso
#' \code{\link{readRangedSummarizedExperiment}}, to read the RangedSummarizedExperiment back into the R session.
#' 
#' @examples
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' gr <- GRanges("chrA", IRanges(1:1000, width=10))
#' se <- SummarizedExperiment(list(counts=mat), rowRanges=gr)
#' se$stuff <- LETTERS[1:10]
#' rowData(se)$blah <- runif(1000)
#' metadata(se)$whee <- "YAY"
#' 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @aliases 
#' stageObject,RangedSummarizedExperiment-method
#' @name saveRangedSummarizedExperiment
NULL

#' @export
#' @export
#' @rdname saveRangedSummarizedExperiment
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom S4Vectors mcols<-
setMethod("saveObject", "RangedSummarizedExperiment", 
function(x, path, ...) {
    # Note that the use of callNextMethod() means that we cannot respond to
    # application overrides for the SummarizedExperiment base class. Developers
    # should just pretend that saveObject,RSE-method copied all of the code
    # from saveObject,SE-method; callNextMethod() is an implementation detail.
    #
    # This simplifies the dispatch and ensures that an override is only called
    # once. Consider the alternative - namely, casting to the next subclass
    # and then calling altSaveObject to respect the override. This would call
    # the override's SE method repeatedly for every step from the subclass to
    # SE. If the override's behavior is not idempotent, we have a problem.
    # 
    # So, if an application wants to set an override for all SEs, then it
    # should define an altSaveObject,SE-method and then call it. If the
    # override is slightly different for particular SE subclasses, developers
    # should just duplicate the common override logic in the altSaveObject
    # methods for affected subclasses, rather than expecting some injection of
    # the overriding method into the saveObject dispatch hierarchy.
    callNextMethod()

    if (!emptyRowRanges(x)) {
        rr <- rowRanges(x)
        mcols(rr) <- NULL # removing mcols as these are absorbed into the SE's rowData.
        names(rr) <- NULL # names are also absorbed into the SE's rowData.

        tryCatch({
            altSaveObject(rr, file.path(path, "row_ranges"), ...) 
        }, error=function(e) {
            stop("failed to stage 'rowRanges(<", class(x)[1], ">)'\n  - ", e$message)
        })
    }

    info <- readObjectFile(path)
    info$ranged_summarized_experiment <- list(version="1.0")
    saveObjectFile(path, "ranged_summarized_experiment", info)

    invisible(NULL)
})

##################################
######### OLD STUFF HERE #########
##################################

#' @export
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom alabaster.base .stageObject .writeMetadata
#' @importMethodsFrom alabaster.ranges stageObject
#' @import methods
setMethod("stageObject", "RangedSummarizedExperiment", function(x, dir, path, child=FALSE, ..., skip.ranges=FALSE) {
    dir.create(file.path(dir, path), showWarnings=FALSE)
    meta <- callNextMethod()

    if (!skip.ranges && !emptyRowRanges(x)) {
        rd.processed <- tryCatch({
            rd.info <- .stageObject(rowRanges(x), dir, file.path(path, "rowranges"), mcols.name=NULL, child=TRUE) # skipping the mcols, as this is the row_data.
            .writeMetadata(rd.info, dir=dir)
        }, error=function(e) {
            stop("failed to stage 'rowRanges(<", class(x)[1], ">)'\n  - ", e$message)
        })

        meta$summarized_experiment$row_ranges <- list(resource=rd.processed)
    }

    meta
})

#' Read a RangedSummarizedExperiment from disk
#'
#' Read a \linkS4class{RangedSummarizedExperiment} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created using the \code{\link{saveObject}} method for \linkS4class{RangedSummarizedExperiment} objects.
#' @param metadata Named list of metadata for this object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments passed to \code{\link{readSummarizedExperiment}} and internal \code{\link{altReadObject}} calls.
#' 
#' @return A \linkS4class{RangedSummarizedExperiment} object.
#'
#' @author Aaron Lun
#' @seealso
#' \code{"\link{saveObject,RangedSummarizedExperiment-method}"}, to save the RangedSummarizedExperiment to disk.
#'
#' @examples
#' # Mocking up an experiment:
#' mat <- matrix(rpois(10000, 10), ncol=10)
#' colnames(mat) <- letters[1:10]
#' rownames(mat) <- sprintf("GENE_%i", seq_len(nrow(mat)))
#'
#' gr <- GRanges("chrA", IRanges(1:1000, width=10))
#' se <- SummarizedExperiment(list(counts=mat), rowRanges=gr)
#' se$stuff <- LETTERS[1:10]
#' rowData(se)$blah <- runif(1000)
#' metadata(se)$whee <- "YAY"
#' 
#' tmp <- tempfile()
#' saveObject(se, tmp)
#' readObject(tmp)
#'
#' @export
#' @importFrom SummarizedExperiment SummarizedExperiment rowData rowData<- rowRanges<-
#' @import alabaster.base
readRangedSummarizedExperiment <- function(path, metadata, ...) {
    # We don't try to respect application overrides when loading the base
    # instance. Application developers should just pretend that we copied the
    # code from readSummarizedExperiment, rather than trying to inject in
    # custom code at this point, which gets too complicated - see the
    # associated commentary for saveObject,SummarizedExperiment-method.
    se <- readSummarizedExperiment(path, metadata=metadata, ...)

    rrdir <- file.path(path, "row_ranges")
    if (file.exists(rrdir)) {
        # Avoid overriding the old rowData with the rowRanges's mcols.
        rr <- altReadObject(rrdir, ...)
        old.rd <- rowData(se)
        old.names <- rownames(se)
        rowRanges(se) <- rr
        rowData(se) <- old.rd
        rownames(se) <- old.names
    } else {
        se <- as(se, "RangedSummarizedExperiment")
    }

    se
}

## ----echo=FALSE---------------------------------------------------------------
library(BiocStyle)
self <- Biocpkg("alabaster.se")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)

## -----------------------------------------------------------------------------
# Example taken from ?SummarizedExperiment
library(SummarizedExperiment)
nrows <- 200
ncols <- 6
counts <- matrix(rpois(nrows * ncols, 10), nrows, ncols)
rowRanges <- GRanges(
    rep(c("chr1", "chr2"), c(50, 150)),
    IRanges(floor(runif(200, 1e5, 1e6)), width=100),
    strand=sample(c("+", "-"), 200, TRUE)
)
colData <- DataFrame(
    Treatment=rep(c("ChIP", "Input"), 3), 
    row.names=LETTERS[1:6]
)
rse <- SummarizedExperiment(
    assays=SimpleList(counts=counts),
    rowRanges=rowRanges, 
    colData=colData
)
rownames(rse) <- sprintf("GENE_%03d", 1:200)
rse

library(alabaster.se)
tmp <- tempfile()
saveObject(rse, tmp)

list.files(tmp, recursive=TRUE)

## -----------------------------------------------------------------------------
roundtrip <- readObject(tmp)
roundtrip

## -----------------------------------------------------------------------------
sessionInfo()

---
title: Saving `SummarizedExperiment`s to artifacts and back again
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: alabaster.se
date: "Revised: September 22, 2022"
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Saving and loading SummarizedExperiments}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE}
library(BiocStyle)
self <- Biocpkg("alabaster.se")
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Overview 

The `r self` package implements methods to save `SummarizedExperiment` objects to file artifacts and load them back into R.
Check out the `r Biocpkg("alabaster.base")` for more details on the motivation and concepts of the **alabaster** framework.

# Quick start

Given a `(Ranged)SummarizedExperiment`, we can use `saveObject()` to save it inside a staging directory:

```{r}
# Example taken from ?SummarizedExperiment
library(SummarizedExperiment)
nrows <- 200
ncols <- 6
counts <- matrix(rpois(nrows * ncols, 10), nrows, ncols)
rowRanges <- GRanges(
    rep(c("chr1", "chr2"), c(50, 150)),
    IRanges(floor(runif(200, 1e5, 1e6)), width=100),
    strand=sample(c("+", "-"), 200, TRUE)
)
colData <- DataFrame(
    Treatment=rep(c("ChIP", "Input"), 3), 
    row.names=LETTERS[1:6]
)
rse <- SummarizedExperiment(
    assays=SimpleList(counts=counts),
    rowRanges=rowRanges, 
    colData=colData
)
rownames(rse) <- sprintf("GENE_%03d", 1:200)
rse

library(alabaster.se)
tmp <- tempfile()
saveObject(rse, tmp)

list.files(tmp, recursive=TRUE)
```

We can then load it back into the session with `readObject()`.

```{r}
roundtrip <- readObject(tmp)
roundtrip
```

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveRangedSummarizedExperiment.R
\name{saveRangedSummarizedExperiment}
\alias{saveRangedSummarizedExperiment}
\alias{stageObject,RangedSummarizedExperiment-method}
\alias{saveObject,RangedSummarizedExperiment-method}
\title{Save a RangedSummarizedExperiment to disk}
\usage{
\S4method{saveObject}{RangedSummarizedExperiment}(x, path, ...)
}
\arguments{
\item{x}{A \linkS4class{RangedSummarizedExperiment} object or one of its subclasses.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments to pass to \code{"\link{saveObject,SummarizedExperiment-method}"} and internal \code{\link{altSaveObject}} calls.}
}
\value{
\code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{RangedSummarizedExperiment} to its on-disk representation.
}
\examples{
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_\%i", seq_len(nrow(mat)))

gr <- GRanges("chrA", IRanges(1:1000, width=10))
se <- SummarizedExperiment(list(counts=mat), rowRanges=gr)
se$stuff <- LETTERS[1:10]
rowData(se)$blah <- runif(1000)
metadata(se)$whee <- "YAY"

tmp <- tempfile()
saveObject(se, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readRangedSummarizedExperiment}}, to read the RangedSummarizedExperiment back into the R session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readRangedSummarizedExperiment.R
\name{readRangedSummarizedExperiment}
\alias{readRangedSummarizedExperiment}
\title{Read a RangedSummarizedExperiment from disk}
\usage{
readRangedSummarizedExperiment(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created using the \code{\link{saveObject}} method for \linkS4class{RangedSummarizedExperiment} objects.}

\item{metadata}{Named list of metadata for this object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments passed to \code{\link{readSummarizedExperiment}} and internal \code{\link{altReadObject}} calls.}
}
\value{
A \linkS4class{RangedSummarizedExperiment} object.
}
\description{
Read a \linkS4class{RangedSummarizedExperiment} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
# Mocking up an experiment:
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_\%i", seq_len(nrow(mat)))

gr <- GRanges("chrA", IRanges(1:1000, width=10))
se <- SummarizedExperiment(list(counts=mat), rowRanges=gr)
se$stuff <- LETTERS[1:10]
rowData(se)$blah <- runif(1000)
metadata(se)$whee <- "YAY"

tmp <- tempfile()
saveObject(se, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,RangedSummarizedExperiment-method}"}, to save the RangedSummarizedExperiment to disk.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveSummarizedExperiment.R
\name{saveSummarizedExperiment}
\alias{saveSummarizedExperiment}
\alias{stageObject,SummarizedExperiment-method}
\alias{saveObject,SummarizedExperiment-method}
\title{Save a SummarizedExperiment to disk}
\usage{
\S4method{saveObject}{SummarizedExperiment}(x, path, SummarizedExperiment.allow.dataframe.assay = FALSE, ...)
}
\arguments{
\item{x}{A \linkS4class{SummarizedExperiment} object or one of its subclasses.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{SummarizedExperiment.allow.dataframe.assay}{Logical scalar indicating whether to allow data frames as assays of \code{x}.}

\item{...}{Further arguments to pass to internal \code{\link{altSaveObject}} calls.}
}
\value{
\code{x} is saved into \code{path} and \code{NULL} is invisibly returned.
}
\description{
Save a \linkS4class{SummarizedExperiment} to its on-disk representation.
}
\details{
By default, we consider the presence of data frames in the assays to be an error.
Users should coerce these into an appropriate matrix type, e.g., a dense matrix or a sparse dgCMatrix.
If a DataFrame as an assay is truly desired, users may set \code{\link{options}(alabaster.se.reject_data.frames=FALSE)} to skip the error.
Note that this only works for \linkS4class{DataFrame} objects - data.frame objects will not be saved correctly.
}
\examples{
mat <- matrix(rpois(10000, 10), ncol=10)
colnames(mat) <- letters[1:10]
rownames(mat) <- sprintf("GENE_\%i", seq_len(nrow(mat)))

se <- SummarizedExperiment(list(counts=mat))
se$stuff <- LETTERS[1:10]
rowData(se)$blah <- runif(1000)
metadata(se)$whee <- "YAY"

tmp <- tempfile()
saveObject(se, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readSummarizedExperiment}}, to read the SummarizedExperiment back into the R session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/emptyRowRanges.R
\name{emptyRowRanges}
\alias{emptyRowRanges}
\title{Is the \code{rowRanges} empty?}
\usage{
emptyRowRanges(x)
}
\arguments{
\item{x}{A \linkS4class{RangedSummarizedExperiment} object or the contents of its \code{\link{rowRanges}}.}
}
\value{
A logical scalar indicating whether \code{x} has empty \code{rowRanges}.
}
\description{
Check the \code{\link{rowRanges}} of a \linkS4class{RangedSummarizedExperiment} is empty, 
i.e., a \linkS4class{GRangesList} with no ranges.
}
\details{
Metadata in \code{\link{mcols}} is ignored for the purpose of this discussion, 
as this can be moved to the \code{\link{rowData}(x)} of the base \linkS4class{SummarizedExperiment} class without loss.
In other words, non-empty \code{\link{mcols}} will not be used to determine that the \code{rowRanges} is not empty.
However, non-empty fields in the \code{\link{metadata}} or in the inner \code{\link{mcols}} of the \linkS4class{GRanges} will trigger a non-emptiness decision.
}
\examples{
emptyRowRanges(SummarizedExperiment())
emptyRowRanges(SummarizedExperiment(rowRanges=GRanges()))
emptyRowRanges(SummarizedExperiment(rowRanges=GRangesList()))
}
